xindy(1)

NAME
xindy - create sorted and tagged index from raw index

SYNOPSIS
 xindy [-V?h] [-qv] [-d magic] [-o outfile.ind] [-t log] \
       [-L lang] [-C codepage] [-M module] [-I input] \
       [--interactive] [--mem-file=xindy.mem] \
       [idx0 idx1 ...]

  GNU-Style Long Options for Short Options:
 -V / --version
 -? / -h / --help
 -q / --quiet
 -v / --verbose
 -d / --debug          (multiple times)
 -o / --out-file
 -t / --log-file
 -L / --language
 -C / --codepage
 -M / --module         (multiple times)
 -I / --input-markup   (supported: latex, xelatex, omega, xindy)

DESCRIPTION
xindy is the formatter-independent command of xindy, the flexible indexing system. It takes a raw index as input, and produces a merged, sorted and tagged index. Merging, sorting, and tagging is controlled by xindy style files.

Files with the raw index are passed as arguments. If no arguments are passed, the raw index will be read from standard input.

xindy is completely described in its manual that you will find on its Web Site, http://www.xindy.org/. A good introductionary description appears in the indexing chapter of the LaTeX Companion (2nd ed.)

If you want to produce an index for LaTeX documents, the command texindy(1) is probably more of interest for you. It is a wrapper for xindy that turns on many LaTeX conventions by default.

OPTIONS

"--version" / -V
    output version numbers of all relevant components and exit.

"--help" / -h / -?
    output usage message with options explanation.

"--quiet" / -q
    Don't output progress messages. Output only error messages.

"--verbose" / -v
    Output verbose progress messages.

"--debug" magic / -d magic
    Output debug messages, this option may be specified multiple times. magic determines what is output:

     magic          remark
     ------------------------------------------------------------
     script         internal progress messages of driver scripts
     keep_tmpfiles  don't discard temporary files
     markup         output markup trace, as explained in xindy manual
     level=n        log level, n is 0 (default), 1, 2, or 3

"--out-file" outfile.ind / -o outfile.ind
    Output index to file outfile.ind. If this option is not passed, the name of the output file is the base name of the first argument and the file extension ind. If the raw index is read from standard input, this option is mandatory.

"--log-file" log.ilg / -t log.ilg
    Output log messages to file log.ilg. These log messages are independent from the progress messages that you can influence with "--debug" or "--verbose".

"--language" lang / -L lang
    The index is sorted according to the rules of language lang. These rules are encoded in a xindy module created by make-rules.

    If no input encoding is specified via "--codepage" or enforced by input markup, a xindy module for that language is searched with a latin, a cp, an iso, ascii, or utf8 encoding, in that order.

    Language modules are either placed in the lang or in the contrib/lang sub-directory of the modules base directory.

"--codepage" enc / -C enc
    The raw input is in input encoding enc. This information is used to select the correct xindy sort module and output encoding of letter group headings.

    When "xelatex" or "omega" input markup is used, "utf8" is always used as codepage, then this option is ignored.

    If raw input is in LICR, texindy(1) should be used instead of xindy(1). It will activate a mapping of inputenc encoding for "latex" input markup to the chosen raw input codepage.

"--module" module / -M module
    Load the xindy module module.xdy. This option may be specified multiple times. The modules are searched in the xindy search path that can be changed with the environment variable "XINDY_SEARCHPATH".

"--input-markup" input / -I input
    Specifies the input markup of the raw index. Supported values for input are "latex", "xelatex", "omega", and "xindy".

    "latex" and "xelatex" input markup is the one that is emitted by default from the LaTeX kernel, or by the "index" macro package of David Jones. ^^-notation of single byte characters is supported. Remapping of LICR-encoded characters is not done; use texindy(1) for that. Use input markup "latex" if you use standard LaTeX or pdfLaTeX and use input markup "xelatex" if you use XeLaTeX or LuaLaTeX.

    "omega" input markup is like "latex" input markup, but with Omega's ^^-notation as encoding for non-ASCII characters.

    "xindy" input markup is specified in the xindy manual.

"--interactive"
    Start xindy in interactive mode. You will be in a xindy read-eval-loop where xindy language expressions are read and evaluated interactively.

"--mem-file" xindy.mem
    This option is only usable for developers or in very rare situations. The compiled xindy kernel is stored in a so-called memory file, canonically named xindy.mem, and located in the xindy library directory. This option allows to use another xindy kernel.

SUPPORTED LANGUAGES / CODEPAGES
The following languages are supported:

  Latin scripts
 albanian      gypsy             portuguese
 croatian      hausa             romanian
 czech         hungarian         russian-iso
 danish        icelandic         slovak-small
 english       italian           slovak-large
 esperanto     kurdish-bedirxan  slovenian
 estonian      kurdish-turkish   spanish-modern
 finnish       latin             spanish-traditional
 french        latvian           swedish
 general       lithuanian        turkish
 german-din    lower-sorbian     upper-sorbian
 german-duden  norwegian         vietnamese
 greek-iso     polish

German recognizes two different sorting schemes to handle umlauts: normally, "ae" is sorted like "ae", but in phone books or dictionaries, it is sorted like "a". The first scheme is known as DIN order, the second as Duden order.

"*-iso" language names assume that the raw index entries are in ISO 8859-9 encoding.

"gypsy" is a northern Russian dialect.

  Cyrillic scripts
 belarusian    mongolian         serbian
 bulgarian     russian           ukrainian
 macedonian

  Other scripts
 greek         klingon

  Available Codepages
This is not yet written. You can look them up in your xindy distribution, in the modules/lang/language/ directory (where language is your language). They are named variant-codepage-lang.xdy, where variant- is most often empty (for german, it's "din5007" and "duden"; for spanish, it's "modern" and "traditional", etc.)

 < Describe available codepages for each language >

 < Describe relevance of codepages (as internal representation) for
   LaTeX inputenc >

ENVIRONMENT

"XINDY_SEARCHPATH"
    A list of directories where the xindy modules are searched in. No subtree searching is done (as in TDS-conformant TeX).

    If this environment variable is not set, the default is used: ".:"modules_dir":"modules_dir"/base". modules_dir is determined at run time, relative to the xindy command location: Either it's ../modules, that's the case for opt-installations. Or it's ../lib/xindy/modules, that's the case for usr-installations.

"XINDY_LIBDIR"
    Library directory where xindy.mem is located.

    The modules directory may be a subdirectory, too.

COMPATIBILITY TO MAKEINDEX
xindy does not claim to be completely compatible with MakeIndex, that would prevent some of its enhancements. That said, we strive to deliver as much compatibility as possible. The most important incompatibilities are

•   For raw index entries in LaTeX syntax, "\index{aaa|bbb}" is interpreted differently. For MakeIndex "bbb" is markup that is output as a LaTeX tag for this page number. For xindy, this is a location attribute, an abstract identifier that will be later associated with markup that should be output for that attribute.

    For straight-forward usage, when "bbb" is "textbf" or similar, we supply location attribute definitions that mimic MakeIndex's behaviour.

    For more complex usage, when "bbb" is not an identifier, no such compatibility definitions exist and may also not been created with current xindy. In particular, this means that by default the LaTeX package "hyperref" will create raw index files that cannot be processed with xindy. This is not a bug, this is the unfortunate result of an intented incompatibility. It is currently not possible to get both hyperref's index links and use xindy.

    A similar situation is reported to exist for the "memoir" LaTeX class.

    Programmers who know Common Lisp and Lex and want to work on a remedy should please contact the author.

•   If you have an index rage and a location attribute, e.g., "\index{key\(attr}" starts the range, one needs (1) to specify that attribute in the range closing entry as well (i.e., as "\index{key\)attr}") and (2) one needs to declare the index attribute in an xindy style file.

    MakeIndex will output the markup "\attr{page1--page2}" for such a construct. This is not possible to achieve in xindy, output will be "\attrMarkup{page1}--\attrMarkup{page2}". (This is actually considered a bug, but not a high priority one.)

    The difference between MakeIndex page number tags and xindy location attributes was already explained in the previous item.

•   The MakeIndex compatibility definitions support only the default raw index syntax and markup definition. It is not possible to configure raw index parsing or use a MakeIndex style file to describe output markup.

KNOWN ISSUES
Option -q also prevents output of error messages. Error messages should be output on stderr, progress messages on stdout.

There should be a way to output the final index to stdout. This would imply -q, of course.

LaTeX raw index parsing should be configurable.

Codepage "utf8" should be supported for all languages, and should be used as internal codepage for LaTeX inputenc re-encoding.

SEE ALSO
texindy(1), tex2xindy(1)

AUTHOR
Joachim Schrod

LEGALESE
Copyright (C) 2004-2014 by Joachim Schrod.

xindy is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.